<?php
/**
 * Magento Module developed by NoStress Commerce
 *
 * NOTICE OF LICENSE
 *
 * This program is licensed under the Koongo software licence (by NoStress Commerce). 
 * With the purchase, download of the software or the installation of the software 
 * in your application you accept the licence agreement. The allowed usage is outlined in the
 * Koongo software licence which can be found under https://docs.koongo.com/display/koongo/License+Conditions
 *
 * Any modification or distribution is strictly forbidden. The license
 * grants you the installation in one application. For multiuse you will need
 * to purchase further licences at https://store.koongo.com/.
 *
 * See the Koongo software licence agreement for more details.
 * @copyright Copyright (c) 2017 NoStress Commerce (http://www.nostresscommerce.cz, http://www.koongo.com/)
 *
 */ 

/** 
* Model for Export
* 
* @category Nostress 
* @package Nostress_Nscexport
* 
*/

abstract class Nostress_Nscexport_Model_Mysql4_Abstract extends Mage_Core_Model_Mysql4_Abstract
{     
	const TIME = 'time';
    const DATE = 'date';
    const DATE_TIME = 'date_time';
       
    protected function _runQuery($queryString,$tableName = "", $message = "")
    {
    	if (!empty($message)) {
    		$this->helper()->log("Table: {$tableName}");
    		$this->helper()->log($message);
    		//$this->helper->log($queryString);
    		$this->helper()->log(base64_encode($queryString));
    	}
    	
    	if(!isset($queryString) || $queryString == "")
    		return $this;
    	$this->beginTransaction();
        try {
            
            $this->_getWriteAdapter()->query($queryString);       
            $this->commit();
        }
        catch (Exception $e){
            $this->rollBack();
            throw $e;
        }
        return $this;
    }
    
    protected function _runSelectQuery($select, $tableName = "", $message = "")
    {
        if (!empty($message)) {
            $queryString = $select->__toString();
            $this->helper()->log("Table: {$tableName}");
            $this->helper()->log($message);
            //$this->helper->log($queryString);
            $this->helper()->log(base64_encode($queryString));
        }
    	return $this->getReadConnection()->fetchAll($select);
    }
    
	protected function _runOneRowSelectQuery($queryString)
    {    	
    	return $this->getReadConnection()->fetchRow($queryString);
    }
    
    protected function _getTableColumns($tableName)
    {    	
    	return $this->_getWriteAdapter()->describeTable($tableName);
    		
    }
}