<?php
/**
 * Magento Module developed by NoStress Commerce
 *
 * NOTICE OF LICENSE
 *
 * This program is licensed under the Koongo software licence (by NoStress Commerce). 
 * With the purchase, download of the software or the installation of the software 
 * in your application you accept the licence agreement. The allowed usage is outlined in the
 * Koongo software licence which can be found under https://docs.koongo.com/display/koongo/License+Conditions
 *
 * Any modification or distribution is strictly forbidden. The license
 * grants you the installation in one application. For multiuse you will need
 * to purchase further licences at https://store.koongo.com/.
 *
 * See the Koongo software licence agreement for more details.
 * @copyright Copyright (c) 2017 NoStress Commerce (http://www.nostresscommerce.cz, http://www.koongo.com/)
 *
 */ 

/** 
* Model for Export
* 
* @category Nostress 
* @package Nostress_Nscexport
* 
*/

class Nostress_Nscexport_Model_Mysql4_Cache_Categorymaxlevel extends Nostress_Nscexport_Model_Mysql4_Cache
{   	
	protected $_cacheName = 'Categorymaxlevel';
    protected $_lowestLevel = 0;
		
    public function _construct()
    {    
        $this->_init('nscexport/cache_categorymaxlevel', 'product_id');
    }
    
    protected function reloadTable()
    {
    	$sql = $this->getCleanMainTableSql();
    	$sql .= $this->getProductCategoryMaxLevelInsertSql();
    	$sql .= $this->getProductCategoryMaxLevelUpdateSql();
//      	echo $sql."<br>";
//      	exit();
    	$this->_runQuery($sql);
    }        

    protected function getProductCategoryMaxLevelInsertSql()
    {   	    	
		$sql =  "INSERT INTO {$this->getMainTable()} ";
		$sql .= $this->getSubSelectTable($this->getProductCategoryMaxLevelSelect()).";";
		return $sql;
    }
    
    protected function getProductCategoryMaxLevelSelect()
    {
    	$mainTableAlias = $this->getProductFlatTable(true);
    	$mainTable = $this->getProductFlatTable();    	    	
    	
    	$catProdTableAlias = self::CCPI;
    	$catProdTable = $this->getTable('catalog/category_product_index');    	    	
    	
    	$catTableAlias = $this->getCategoryFlatTable(true);
    	$catTable = $this->getCategoryFlatTable();
    	
    	$select = $this->getEmptySelect();
    	$select->from(array($mainTableAlias => $mainTable), array( "entity_id as product_id" ,"({$this->getStoreId()}) as store_id"));
    	
    	$select->joinLeft(
    			array($catProdTableAlias => $catProdTable),
    			$catProdTableAlias.'.product_id='.$mainTableAlias.'.entity_id AND '.$catProdTableAlias.'.store_id = '.$this->getStoreId(),
    			array('category_id')
    	);
    	
    	$select->joinLeft(
    			array($catTableAlias => $catTable),
    			$catProdTableAlias.'.category_id='.$catTableAlias.'.entity_id',
    			array('MAX(level) as max_level')
    	);
    	
    	$select->group($mainTableAlias.'.entity_id');
    	
    	return $select;
    }
    
    protected function getProductCategoryMaxLevelUpdateSql()
    {
    	$mainTableAlias = 'main_table';
    	$mainTable = $this->getMainTable();
    	 
    	$catProdTableAlias = self::CCPI;
    	$catProdTable = $this->getTable('catalog/category_product_index');
    	 
    	$catTableAlias = $this->getCategoryFlatTable(true);
    	$catTable = $this->getCategoryFlatTable();
    	
    	$sql = "UPDATE {$mainTable} AS {$mainTableAlias} ";
    	$sql .= "LEFT JOIN {$catProdTable} AS {$catProdTableAlias} ON {$catProdTableAlias}.product_id = {$mainTableAlias}.product_id AND {$catProdTableAlias}.store_id = {$this->getStoreId()} ";
    	$sql .= "INNER JOIN {$catTable} AS {$catTableAlias} ON {$catTableAlias}.entity_id = {$catProdTableAlias}.category_id AND {$catTableAlias}.level = {$mainTableAlias}.max_level ";
    	$sql .= "SET {$mainTableAlias}.category_id = {$catTableAlias}.entity_id";
    	return $sql;
    }           
	
	protected function getCleanMainTableSql()
	{
		return "DELETE FROM {$this->getMainTable()} WHERE store_id = {$this->getStoreId()};";
	}
}
