<?php
/**
 * Magento Module developed by NoStress Commerce
 *
 * NOTICE OF LICENSE
 *
 * This program is licensed under the Koongo software licence (by NoStress Commerce). 
 * With the purchase, download of the software or the installation of the software 
 * in your application you accept the licence agreement. The allowed usage is outlined in the
 * Koongo software licence which can be found under https://docs.koongo.com/display/koongo/License+Conditions
 *
 * Any modification or distribution is strictly forbidden. The license
 * grants you the installation in one application. For multiuse you will need
 * to purchase further licences at https://store.koongo.com/.
 *
 * See the Koongo software licence agreement for more details.
 * @copyright Copyright (c) 2017 NoStress Commerce (http://www.nostresscommerce.cz, http://www.koongo.com/)
 *
 */ 

/** 
* Model for Export
* 
* @category Nostress 
* @package Nostress_Nscexport
* 
*/

class Nostress_Nscexport_Model_Mysql4_Cache_Enginecategory extends Nostress_Nscexport_Model_Mysql4_Cache
{   	
	protected $_cacheName = 'Enginecategory';
   
	
    public function _construct()
    {    
        $this->_init('nscexport/cache_enginecategory', 'entity_id');
    }
    
	protected function defineColumns()
    {
		parent::defineColumns();       	     
    }
    
    protected function reloadTable()
    {
    	$sql = $this->getTaxonomyCategoriesUpdateSql();
      	//echo $sql."<br>";
      	//exit();
    	$this->_runQuery($sql);
    }
    
    
    public function getTaxonomyCategoriesSelect()
    {    	
    	$taxonomyColumn = $this->getTaxonomyColumnName();
    	if(!isset($taxonomyColumn))
    		return false;
    	
    	$locale = $this->getTaxonomyLocale();
    	$code = $this->getTaxonomyCode();
    	
    	$mainTable = $this->getCategoryFlatTable();
    	$mainTableAlias = $this->getCategoryFlatTable(true);
    	$joinTableAlias = self::NEC;
    	$joinTable =  $this->getTable('nscexport/enginecategory');
    	 
    	$select = $this->getEmptySelect();
      $select->distinct(true);
    	$select->from(array($mainTableAlias => $mainTable), array());
    	$select->join(
    			array($joinTableAlias => $joinTable),
    			"{$joinTableAlias}.hash = {$mainTableAlias}.{$taxonomyColumn} ",
    			"*"
    	);    	    	
    	$select->where('locale=?', $locale);
    	$select->where('taxonomy_code=?', $code);
    	
    	return $select;
    }
    
    public function setTaxonomyCode($code)
    {
    	$data = $this->_data;
    	if(empty($data))
    		$data = array();
    	$data[self::TAXONOMY_CODE] = $code;
    	$this->setData($data);
    }
    
    protected function getTaxonomyCategoriesUpdateSql()
    {
    	$storeId = $this->getStoreId();
    	$sql = $this->getCleanMainTableSql();
		$sql .=  "INSERT INTO {$this->getMainTable()} ";
		$sql .= $this->getSubSelectTable($this->getTaxonomyCategoriesSelect()).";";
		return $sql;
    }
    
	protected function getCleanMainTableSql()
	{
		$locale = $this->getTaxonomyLocale();
		$code = $this->getTaxonomyCode();
		
		return "DELETE FROM {$this->getMainTable()} WHERE taxonomy_code = '{$code}' AND locale = '{$locale}';";
	}
}
