<?php
/**
 * Magento Module developed by NoStress Commerce
 *
 * NOTICE OF LICENSE
 *
 * This program is licensed under the Koongo software licence (by NoStress Commerce). 
 * With the purchase, download of the software or the installation of the software 
 * in your application you accept the licence agreement. The allowed usage is outlined in the
 * Koongo software licence which can be found under https://docs.koongo.com/display/koongo/License+Conditions
 *
 * Any modification or distribution is strictly forbidden. The license
 * grants you the installation in one application. For multiuse you will need
 * to purchase further licences at https://store.koongo.com/.
 *
 * See the Koongo software licence agreement for more details.
 * @copyright Copyright (c) 2017 NoStress Commerce (http://www.nostresscommerce.cz, http://www.koongo.com/)
 *
 */ 

/** 
* Model for Export
* 
* @category Nostress 
* @package Nostress_Nscexport
* 
*/

class Nostress_Nscexport_Model_Mysql4_Cache_Tax extends Nostress_Nscexport_Model_Mysql4_Cache
{   	    
	protected $_cacheName = 'Tax';
	
    public function _construct()
    {    
        $this->_init('nscexport/cache_tax', 'tax_class_id');
    }
    
    protected function reloadTable()
    {
    	$sql = $this->getUpdateSql();
    	//echo $sql."<br>";
    	//exit();
    	$this->_runQuery($sql);
    }
    
    protected function getUpdateSql()
    {
    	$storeId = $this->getStoreId();
    	$store = Mage::app()->getStore($storeId);
    	$sql = $this->getCleanMainTableSql();
    	
    	$calc = Mage::getSingleton('tax/calculation');
    	$rates = $calc->getRatesForAllProductTaxClasses($calc->getRateRequest(null,null,null,$store));

    	foreach ($rates as $class=>$rate) 
    	{
    		$sql.= $this->getInsertCommand($class,$storeId,$rate)."; ";      		    		    		
    	}
		return $sql;
    }

    protected function getInsertCommand($taxClass,$storeId,$taxPercent)
    {
    	$taxPercent /= 100; 
    	
    	$sql =  "INSERT INTO {$this->getMainTable()} VALUES (";
    	$sql.= "'{$taxClass}','{$storeId}','{$taxPercent}' )";
    	return $sql;    	
    }   
	
	protected function getCleanMainTableSql()
	{
		return "DELETE FROM {$this->getMainTable()} WHERE store_id = {$this->getStoreId()};";
	}
}