<?php
/**
 * Magento Module developed by NoStress Commerce
 *
 * NOTICE OF LICENSE
 *
 * This program is licensed under the Koongo software licence (by NoStress Commerce). 
 * With the purchase, download of the software or the installation of the software 
 * in your application you accept the licence agreement. The allowed usage is outlined in the
 * Koongo software licence which can be found under https://docs.koongo.com/display/koongo/License+Conditions
 *
 * Any modification or distribution is strictly forbidden. The license
 * grants you the installation in one application. For multiuse you will need
 * to purchase further licences at https://store.koongo.com/.
 *
 * See the Koongo software licence agreement for more details.
 * @copyright Copyright (c) 2017 NoStress Commerce (http://www.nostresscommerce.cz, http://www.koongo.com/)
 *
 */ 

/** 
* Model for Nscexport
* 
* @category Nostress 
* @package Nostress_Nscexport
* 
*/

class Nostress_Nscexport_Model_Mysql4_Enginecategory_Collection extends Mage_Core_Model_Mysql4_Collection_Abstract
{	
	const ENGINE_CODE = 'engine_code';
	const LOCALE = 'locale';
	
	protected $_emptyItem  = null;
	protected $_engine = null;
	protected $_locale = null;
	
    public function _construct()
    {
        parent::_construct();
        $this->_init('nscexport/taxonomy');
    }
    
 	public function addFieldsToFilter($fields)
    {
    	if(!is_array($fields))
    		return;
    	foreach ($fields as $field => $condition)
		{
			$this->addFieldToFilter($field,$condition);
		}
    }
    
	public function addFieldsToSelect($fields)
    {
    	if(!is_array($fields))
    		return;
    		
    	foreach ($fields as $alias => $field)
		{
			$this->addFieldToSelect($field,$alias);
		}
    }
    
    public function getItems()
    {   
    	$items = array(); 	    	
    	foreach(parent::getItems() as $item)
    	{
    		$record = array();
    		foreach ($item->getData() as $label => $value)
    		{
    			$record[$label] = $value;
    		}
    		if(isset($record[Nostress_Nscexport_Model_Taxonomy::C_ID]))
    			$items[$record[Nostress_Nscexport_Model_Taxonomy::C_ID]] = $record;
    		else
    			$items[] = $record;
    	}
    	return $items;
    }
    
    /**
     * Function is neccesary for m 1.4
     * @param unknown_type $field
     * @param unknown_type $alias
     */
    public function addFieldToSelect($field, $alias = null)
    {
    	$select = $this->getSelect();    	
    	$columnEntry = array('main_table', $field, $alias);
    	$columns = $select->getPart(Zend_Db_Select::COLUMNS);
    	$columns[] = $columnEntry;
    	$select->setPart(Zend_Db_Select::COLUMNS, $columns);
    }
}