<?php
/**
 * Magento Module developed by NoStress Commerce
 *
 * NOTICE OF LICENSE
 *
 * This program is licensed under the Koongo software licence (by NoStress Commerce). 
 * With the purchase, download of the software or the installation of the software 
 * in your application you accept the licence agreement. The allowed usage is outlined in the
 * Koongo software licence which can be found under https://docs.koongo.com/display/koongo/License+Conditions
 *
 * Any modification or distribution is strictly forbidden. The license
 * grants you the installation in one application. For multiuse you will need
 * to purchase further licences at https://store.koongo.com/.
 *
 * See the Koongo software licence agreement for more details.
 * @copyright Copyright (c) 2017 NoStress Commerce (http://www.nostresscommerce.cz, http://www.koongo.com/)
 *
 */

/**
* Model for Nscexport
*
* @category Nostress
* @package Nostress_Nscexport
*
*/

class Nostress_Nscexport_Model_Mysql4_Submission_Items_Collection extends Mage_Core_Model_Mysql4_Collection_Abstract
{
    public function _construct()
    {
        parent::_construct();
        $this->_init('nscexport/submission_items');
    }
    
    public function getProducts( $profileID, $filter = array()) {
        
         $this->getSelect()
            ->where( 'profile_id = ?', $profileID)
            ->order( 'item_id ASC')
            ;
        if( count( $filter)) {
            foreach( $filter as $key => $value) {
                $this->getSelect()->where( $key." = ?", $value);
            }
        }
        
        $result = $this->getResource()->getReadConnection()->fetchAll( $this->getSelect());
        $items = array();
        foreach( $result as $item) {
            $itemData = json_decode( $item['data'], true);
            unset( $item['data']);
            $item = array_merge( $item, $itemData);
            $items[ $item['item_id']] = $item;
        }
        return $items;
    }
    
    protected function _afterLoad() {
    
        foreach ($this->_items as $item) {
            $itemData = json_decode( $item['data'], true);
            unset( $item['data']);
            $item->addData( $itemData);
        }
    
        return parent::_afterLoad();
    }
}