<?php
/**
 * Magento Module developed by NoStress Commerce
 *
 * NOTICE OF LICENSE
 *
 * This program is licensed under the Koongo software licence (by NoStress Commerce). 
 * With the purchase, download of the software or the installation of the software 
 * in your application you accept the licence agreement. The allowed usage is outlined in the
 * Koongo software licence which can be found under https://docs.koongo.com/display/koongo/License+Conditions
 *
 * Any modification or distribution is strictly forbidden. The license
 * grants you the installation in one application. For multiuse you will need
 * to purchase further licences at https://store.koongo.com/.
 *
 * See the Koongo software licence agreement for more details.
 * @copyright Copyright (c) 2017 NoStress Commerce (http://www.nostresscommerce.cz, http://www.koongo.com/)
 *
 */

/**
* Sql update skript
* Table stores relation product-category, where category has max level from categories related to the product.
* Particular records are distinguished by export profile id.
*
* @category Nostress
* @package Nostress_Nscexport
*
*/



$this->startSetup()->run("

ALTER TABLE `{$this->getTable('nostress_export_enginecategory')}`
		ADD COLUMN `code2`  varchar(255) NULL COMMENT 'Taxonomy category code2.' AFTER `parent_id` ,
		ADD COLUMN `code1`  varchar(255) NULL COMMENT 'Taxonomy category code1.' AFTER `parent_id` ,
		ADD KEY `TAXONOMY_CATEGORY_HASH` (`hash`),
		ADD KEY `TAXONOMY_CATEGORY_CODE` (`taxonomy_code`),
		ADD KEY `TAXONOMY_CATEGORY_LOCALE` (`locale`);
		
ALTER TABLE `{$this->getTable('nostress_export_cache_enginecategory')}`
		ADD COLUMN `code2`  varchar(255) NULL COMMENT 'Taxonomy category code2.' AFTER `parent_id` ,
		ADD COLUMN `code1`  varchar(255) NULL COMMENT 'Taxonomy category code1.' AFTER `parent_id`;
")->endSetup();